package com.qmetry.qaf.bdd.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalBddDslLexer extends Lexer {
    public static final int RULE_EOL=4;
    public static final int RULE_WS=13;
    public static final int RULE_WORD=6;
    public static final int RULE_STRING=8;
    public static final int RULE_NUMBER=10;
    public static final int RULE_SL_COMMENT=12;
    public static final int T__15=15;
    public static final int RULE_PLACEHOLDER=9;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int RULE_STEP_KEYWORD=5;
    public static final int T__14=14;
    public static final int RULE_NL=11;
    public static final int EOF=-1;

    // delegates
    // delegators

    public InternalBddDslLexer() {;} 
    public InternalBddDslLexer(CharStream input) {
        this(input, new RecognizerSharedState());
    }
    public InternalBddDslLexer(CharStream input, RecognizerSharedState state) {
        super(input,state);

    }
    public String getGrammarFileName() { return "InternalBddDsl.g"; }

    // $ANTLR start "T__14"
    public final void mT__14() throws RecognitionException {
        try {
            int _type = T__14;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:11:7: ( 'SCENARIO:' )
            // InternalBddDsl.g:11:9: 'SCENARIO:'
            {
            match("SCENARIO:"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__14"

    // $ANTLR start "T__15"
    public final void mT__15() throws RecognitionException {
        try {
            int _type = T__15;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:12:7: ( 'META-DATA:' )
            // InternalBddDsl.g:12:9: 'META-DATA:'
            {
            match("META-DATA:"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__15"

    // $ANTLR start "T__16"
    public final void mT__16() throws RecognitionException {
        try {
            int _type = T__16;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:13:7: ( 'STEP-DEF:' )
            // InternalBddDsl.g:13:9: 'STEP-DEF:'
            {
            match("STEP-DEF:"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__16"

    // $ANTLR start "T__17"
    public final void mT__17() throws RecognitionException {
        try {
            int _type = T__17;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:14:7: ( 'END' )
            // InternalBddDsl.g:14:9: 'END'
            {
            match("END"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__17"

    // $ANTLR start "RULE_INT"
    public final void mRULE_INT() throws RecognitionException {
        try {
            int _type = RULE_INT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:637:10: ( ( '-' )? ( '0' .. '9' )+ ( '.' ( '0' .. '9' )+ )? )
            // InternalBddDsl.g:637:12: ( '-' )? ( '0' .. '9' )+ ( '.' ( '0' .. '9' )+ )?
            {
            // InternalBddDsl.g:637:12: ( '-' )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0=='-') ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalBddDsl.g:637:12: '-'
                    {
                    match('-'); 

                    }
                    break;

            }

            // InternalBddDsl.g:637:17: ( '0' .. '9' )+
            int cnt2=0;
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( ((LA2_0>='0' && LA2_0<='9')) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalBddDsl.g:637:18: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt2 >= 1 ) break loop2;
                        EarlyExitException eee =
                            new EarlyExitException(2, input);
                        throw eee;
                }
                cnt2++;
            } while (true);

            // InternalBddDsl.g:637:29: ( '.' ( '0' .. '9' )+ )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0=='.') ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalBddDsl.g:637:30: '.' ( '0' .. '9' )+
                    {
                    match('.'); 
                    // InternalBddDsl.g:637:34: ( '0' .. '9' )+
                    int cnt3=0;
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( ((LA3_0>='0' && LA3_0<='9')) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // InternalBddDsl.g:637:35: '0' .. '9'
                    	    {
                    	    matchRange('0','9'); 

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt3 >= 1 ) break loop3;
                                EarlyExitException eee =
                                    new EarlyExitException(3, input);
                                throw eee;
                        }
                        cnt3++;
                    } while (true);


                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_INT"

    // $ANTLR start "RULE_STEP_KEYWORD"
    public final void mRULE_STEP_KEYWORD() throws RecognitionException {
        try {
            int _type = RULE_STEP_KEYWORD;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:639:19: ( ( 'Given' | 'When' | 'Then' | 'And' | 'Using' | 'Having' | 'GIVEN' | 'WHEN' | 'THEN' | 'AND' | 'USING' | 'HAVING' ) ( ' ' | '\\t' )+ )
            // InternalBddDsl.g:639:21: ( 'Given' | 'When' | 'Then' | 'And' | 'Using' | 'Having' | 'GIVEN' | 'WHEN' | 'THEN' | 'AND' | 'USING' | 'HAVING' ) ( ' ' | '\\t' )+
            {
            // InternalBddDsl.g:639:21: ( 'Given' | 'When' | 'Then' | 'And' | 'Using' | 'Having' | 'GIVEN' | 'WHEN' | 'THEN' | 'AND' | 'USING' | 'HAVING' )
            int alt5=12;
            alt5 = dfa5.predict(input);
            switch (alt5) {
                case 1 :
                    // InternalBddDsl.g:639:22: 'Given'
                    {
                    match("Given"); 


                    }
                    break;
                case 2 :
                    // InternalBddDsl.g:639:30: 'When'
                    {
                    match("When"); 


                    }
                    break;
                case 3 :
                    // InternalBddDsl.g:639:37: 'Then'
                    {
                    match("Then"); 


                    }
                    break;
                case 4 :
                    // InternalBddDsl.g:639:44: 'And'
                    {
                    match("And"); 


                    }
                    break;
                case 5 :
                    // InternalBddDsl.g:639:50: 'Using'
                    {
                    match("Using"); 


                    }
                    break;
                case 6 :
                    // InternalBddDsl.g:639:58: 'Having'
                    {
                    match("Having"); 


                    }
                    break;
                case 7 :
                    // InternalBddDsl.g:639:67: 'GIVEN'
                    {
                    match("GIVEN"); 


                    }
                    break;
                case 8 :
                    // InternalBddDsl.g:639:75: 'WHEN'
                    {
                    match("WHEN"); 


                    }
                    break;
                case 9 :
                    // InternalBddDsl.g:639:82: 'THEN'
                    {
                    match("THEN"); 


                    }
                    break;
                case 10 :
                    // InternalBddDsl.g:639:89: 'AND'
                    {
                    match("AND"); 


                    }
                    break;
                case 11 :
                    // InternalBddDsl.g:639:95: 'USING'
                    {
                    match("USING"); 


                    }
                    break;
                case 12 :
                    // InternalBddDsl.g:639:103: 'HAVING'
                    {
                    match("HAVING"); 


                    }
                    break;

            }

            // InternalBddDsl.g:639:113: ( ' ' | '\\t' )+
            int cnt6=0;
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0=='\t'||LA6_0==' ') ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // InternalBddDsl.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    if ( cnt6 >= 1 ) break loop6;
                        EarlyExitException eee =
                            new EarlyExitException(6, input);
                        throw eee;
                }
                cnt6++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_STEP_KEYWORD"

    // $ANTLR start "RULE_PLACEHOLDER"
    public final void mRULE_PLACEHOLDER() throws RecognitionException {
        try {
            int _type = RULE_PLACEHOLDER;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:641:18: ( '<' (~ ( ( '>' | ' ' | '\\t' | '\\n' | '\\r' ) ) )+ '>' )
            // InternalBddDsl.g:641:20: '<' (~ ( ( '>' | ' ' | '\\t' | '\\n' | '\\r' ) ) )+ '>'
            {
            match('<'); 
            // InternalBddDsl.g:641:24: (~ ( ( '>' | ' ' | '\\t' | '\\n' | '\\r' ) ) )+
            int cnt7=0;
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>='\u0000' && LA7_0<='\b')||(LA7_0>='\u000B' && LA7_0<='\f')||(LA7_0>='\u000E' && LA7_0<='\u001F')||(LA7_0>='!' && LA7_0<='=')||(LA7_0>='?' && LA7_0<='\uFFFF')) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalBddDsl.g:641:24: ~ ( ( '>' | ' ' | '\\t' | '\\n' | '\\r' ) )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\b')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\u001F')||(input.LA(1)>='!' && input.LA(1)<='=')||(input.LA(1)>='?' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    if ( cnt7 >= 1 ) break loop7;
                        EarlyExitException eee =
                            new EarlyExitException(7, input);
                        throw eee;
                }
                cnt7++;
            } while (true);

            match('>'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_PLACEHOLDER"

    // $ANTLR start "RULE_STRING"
    public final void mRULE_STRING() throws RecognitionException {
        try {
            int _type = RULE_STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:643:13: ( ( '\"' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) ) )* '\"' | '\\'' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) ) )* '\\'' ) )
            // InternalBddDsl.g:643:15: ( '\"' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) ) )* '\"' | '\\'' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) ) )* '\\'' )
            {
            // InternalBddDsl.g:643:15: ( '\"' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) ) )* '\"' | '\\'' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) ) )* '\\'' )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0=='\"') ) {
                alt10=1;
            }
            else if ( (LA10_0=='\'') ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // InternalBddDsl.g:643:16: '\"' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) ) )* '\"'
                    {
                    match('\"'); 
                    // InternalBddDsl.g:643:20: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) ) )*
                    loop8:
                    do {
                        int alt8=3;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0=='\\') ) {
                            alt8=1;
                        }
                        else if ( ((LA8_0>='\u0000' && LA8_0<='\t')||(LA8_0>='\u000B' && LA8_0<='\f')||(LA8_0>='\u000E' && LA8_0<='!')||(LA8_0>='#' && LA8_0<='[')||(LA8_0>=']' && LA8_0<='\uFFFF')) ) {
                            alt8=2;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // InternalBddDsl.g:643:21: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' )
                    	    {
                    	    match('\\'); 
                    	    if ( input.LA(1)=='\"'||input.LA(1)=='\''||input.LA(1)=='\\'||input.LA(1)=='b'||input.LA(1)=='f'||input.LA(1)=='n'||input.LA(1)=='r'||(input.LA(1)>='t' && input.LA(1)<='u') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;
                    	case 2 :
                    	    // InternalBddDsl.g:643:66: ~ ( ( '\\\\' | '\"' | '\\r' | '\\n' ) )
                    	    {
                    	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop8;
                        }
                    } while (true);

                    match('\"'); 

                    }
                    break;
                case 2 :
                    // InternalBddDsl.g:643:96: '\\'' ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) ) )* '\\''
                    {
                    match('\''); 
                    // InternalBddDsl.g:643:101: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' ) | ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) ) )*
                    loop9:
                    do {
                        int alt9=3;
                        int LA9_0 = input.LA(1);

                        if ( (LA9_0=='\\') ) {
                            alt9=1;
                        }
                        else if ( ((LA9_0>='\u0000' && LA9_0<='\t')||(LA9_0>='\u000B' && LA9_0<='\f')||(LA9_0>='\u000E' && LA9_0<='&')||(LA9_0>='(' && LA9_0<='[')||(LA9_0>=']' && LA9_0<='\uFFFF')) ) {
                            alt9=2;
                        }


                        switch (alt9) {
                    	case 1 :
                    	    // InternalBddDsl.g:643:102: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\"' | '\\'' | '\\\\' )
                    	    {
                    	    match('\\'); 
                    	    if ( input.LA(1)=='\"'||input.LA(1)=='\''||input.LA(1)=='\\'||input.LA(1)=='b'||input.LA(1)=='f'||input.LA(1)=='n'||input.LA(1)=='r'||(input.LA(1)>='t' && input.LA(1)<='u') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;
                    	case 2 :
                    	    // InternalBddDsl.g:643:147: ~ ( ( '\\\\' | '\\'' | '\\r' | '\\n' ) )
                    	    {
                    	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='&')||(input.LA(1)>='(' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop9;
                        }
                    } while (true);

                    match('\''); 

                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_STRING"

    // $ANTLR start "RULE_NUMBER"
    public final void mRULE_NUMBER() throws RecognitionException {
        try {
            int _type = RULE_NUMBER;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:645:13: ( ( '-' )? ( RULE_INT )? '.' RULE_INT ( ( 'E' | 'e' ) ( '-' )? RULE_INT )? )
            // InternalBddDsl.g:645:15: ( '-' )? ( RULE_INT )? '.' RULE_INT ( ( 'E' | 'e' ) ( '-' )? RULE_INT )?
            {
            // InternalBddDsl.g:645:15: ( '-' )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0=='-') ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // InternalBddDsl.g:645:15: '-'
                    {
                    match('-'); 

                    }
                    break;

            }

            // InternalBddDsl.g:645:20: ( RULE_INT )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0=='-'||(LA12_0>='0' && LA12_0<='9')) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // InternalBddDsl.g:645:20: RULE_INT
                    {
                    mRULE_INT(); 

                    }
                    break;

            }

            match('.'); 
            mRULE_INT(); 
            // InternalBddDsl.g:645:43: ( ( 'E' | 'e' ) ( '-' )? RULE_INT )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0=='E'||LA14_0=='e') ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // InternalBddDsl.g:645:44: ( 'E' | 'e' ) ( '-' )? RULE_INT
                    {
                    if ( input.LA(1)=='E'||input.LA(1)=='e' ) {
                        input.consume();

                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        recover(mse);
                        throw mse;}

                    // InternalBddDsl.g:645:54: ( '-' )?
                    int alt13=2;
                    int LA13_0 = input.LA(1);

                    if ( (LA13_0=='-') ) {
                        alt13=1;
                    }
                    switch (alt13) {
                        case 1 :
                            // InternalBddDsl.g:645:54: '-'
                            {
                            match('-'); 

                            }
                            break;

                    }

                    mRULE_INT(); 

                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_NUMBER"

    // $ANTLR start "RULE_SL_COMMENT"
    public final void mRULE_SL_COMMENT() throws RecognitionException {
        try {
            int _type = RULE_SL_COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:647:17: ( '#' (~ ( ( '\\n' | '\\r' ) ) )* RULE_NL )
            // InternalBddDsl.g:647:19: '#' (~ ( ( '\\n' | '\\r' ) ) )* RULE_NL
            {
            match('#'); 
            // InternalBddDsl.g:647:23: (~ ( ( '\\n' | '\\r' ) ) )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( ((LA15_0>='\u0000' && LA15_0<='\t')||(LA15_0>='\u000B' && LA15_0<='\f')||(LA15_0>='\u000E' && LA15_0<='\uFFFF')) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // InternalBddDsl.g:647:23: ~ ( ( '\\n' | '\\r' ) )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            mRULE_NL(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_SL_COMMENT"

    // $ANTLR start "RULE_WORD"
    public final void mRULE_WORD() throws RecognitionException {
        try {
            int _type = RULE_WORD;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:649:11: (~ ( ( '@' | '|' | ' ' | '\\t' | '\\n' | '\\r' ) ) (~ ( ( ' ' | '\\t' | '\\n' | '\\r' ) ) )* )
            // InternalBddDsl.g:649:13: ~ ( ( '@' | '|' | ' ' | '\\t' | '\\n' | '\\r' ) ) (~ ( ( ' ' | '\\t' | '\\n' | '\\r' ) ) )*
            {
            if ( (input.LA(1)>='\u0000' && input.LA(1)<='\b')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\u001F')||(input.LA(1)>='!' && input.LA(1)<='?')||(input.LA(1)>='A' && input.LA(1)<='{')||(input.LA(1)>='}' && input.LA(1)<='\uFFFF') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            // InternalBddDsl.g:649:45: (~ ( ( ' ' | '\\t' | '\\n' | '\\r' ) ) )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( ((LA16_0>='\u0000' && LA16_0<='\b')||(LA16_0>='\u000B' && LA16_0<='\f')||(LA16_0>='\u000E' && LA16_0<='\u001F')||(LA16_0>='!' && LA16_0<='\uFFFF')) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // InternalBddDsl.g:649:45: ~ ( ( ' ' | '\\t' | '\\n' | '\\r' ) )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\b')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\u001F')||(input.LA(1)>='!' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_WORD"

    // $ANTLR start "RULE_WS"
    public final void mRULE_WS() throws RecognitionException {
        try {
            int _type = RULE_WS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:651:9: ( ( ' ' | '\\t' ) )
            // InternalBddDsl.g:651:11: ( ' ' | '\\t' )
            {
            if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_WS"

    // $ANTLR start "RULE_EOL"
    public final void mRULE_EOL() throws RecognitionException {
        try {
            int _type = RULE_EOL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalBddDsl.g:653:10: ( RULE_NL )
            // InternalBddDsl.g:653:12: RULE_NL
            {
            mRULE_NL(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_EOL"

    // $ANTLR start "RULE_NL"
    public final void mRULE_NL() throws RecognitionException {
        try {
            // InternalBddDsl.g:655:18: ( ( '\\r' )? ( '\\n' )? )
            // InternalBddDsl.g:655:20: ( '\\r' )? ( '\\n' )?
            {
            // InternalBddDsl.g:655:20: ( '\\r' )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0=='\r') ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // InternalBddDsl.g:655:20: '\\r'
                    {
                    match('\r'); 

                    }
                    break;

            }

            // InternalBddDsl.g:655:26: ( '\\n' )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0=='\n') ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // InternalBddDsl.g:655:26: '\\n'
                    {
                    match('\n'); 

                    }
                    break;

            }


            }

        }
        finally {
        }
    }
    // $ANTLR end "RULE_NL"

    public void mTokens() throws RecognitionException {
        // InternalBddDsl.g:1:8: ( T__14 | T__15 | T__16 | T__17 | RULE_INT | RULE_STEP_KEYWORD | RULE_PLACEHOLDER | RULE_STRING | RULE_NUMBER | RULE_SL_COMMENT | RULE_WORD | RULE_WS | RULE_EOL )
        int alt19=13;
        alt19 = dfa19.predict(input);
        switch (alt19) {
            case 1 :
                // InternalBddDsl.g:1:10: T__14
                {
                mT__14(); 

                }
                break;
            case 2 :
                // InternalBddDsl.g:1:16: T__15
                {
                mT__15(); 

                }
                break;
            case 3 :
                // InternalBddDsl.g:1:22: T__16
                {
                mT__16(); 

                }
                break;
            case 4 :
                // InternalBddDsl.g:1:28: T__17
                {
                mT__17(); 

                }
                break;
            case 5 :
                // InternalBddDsl.g:1:34: RULE_INT
                {
                mRULE_INT(); 

                }
                break;
            case 6 :
                // InternalBddDsl.g:1:43: RULE_STEP_KEYWORD
                {
                mRULE_STEP_KEYWORD(); 

                }
                break;
            case 7 :
                // InternalBddDsl.g:1:61: RULE_PLACEHOLDER
                {
                mRULE_PLACEHOLDER(); 

                }
                break;
            case 8 :
                // InternalBddDsl.g:1:78: RULE_STRING
                {
                mRULE_STRING(); 

                }
                break;
            case 9 :
                // InternalBddDsl.g:1:90: RULE_NUMBER
                {
                mRULE_NUMBER(); 

                }
                break;
            case 10 :
                // InternalBddDsl.g:1:102: RULE_SL_COMMENT
                {
                mRULE_SL_COMMENT(); 

                }
                break;
            case 11 :
                // InternalBddDsl.g:1:118: RULE_WORD
                {
                mRULE_WORD(); 

                }
                break;
            case 12 :
                // InternalBddDsl.g:1:128: RULE_WS
                {
                mRULE_WS(); 

                }
                break;
            case 13 :
                // InternalBddDsl.g:1:136: RULE_EOL
                {
                mRULE_EOL(); 

                }
                break;

        }

    }


    protected DFA5 dfa5 = new DFA5(this);
    protected DFA19 dfa19 = new DFA19(this);
    static final String DFA5_eotS =
        "\23\uffff";
    static final String DFA5_eofS =
        "\23\uffff";
    static final String DFA5_minS =
        "\1\101\1\111\2\110\1\116\1\123\1\101\14\uffff";
    static final String DFA5_maxS =
        "\1\127\1\151\2\150\1\156\1\163\1\141\14\uffff";
    static final String DFA5_acceptS =
        "\7\uffff\1\1\1\7\1\2\1\10\1\3\1\11\1\4\1\12\1\5\1\13\1\6\1\14";
    static final String DFA5_specialS =
        "\23\uffff}>";
    static final String[] DFA5_transitionS = {
            "\1\4\5\uffff\1\1\1\6\13\uffff\1\3\1\5\1\uffff\1\2",
            "\1\10\37\uffff\1\7",
            "\1\12\37\uffff\1\11",
            "\1\14\37\uffff\1\13",
            "\1\16\37\uffff\1\15",
            "\1\20\37\uffff\1\17",
            "\1\22\37\uffff\1\21",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA5_eot = DFA.unpackEncodedString(DFA5_eotS);
    static final short[] DFA5_eof = DFA.unpackEncodedString(DFA5_eofS);
    static final char[] DFA5_min = DFA.unpackEncodedStringToUnsignedChars(DFA5_minS);
    static final char[] DFA5_max = DFA.unpackEncodedStringToUnsignedChars(DFA5_maxS);
    static final short[] DFA5_accept = DFA.unpackEncodedString(DFA5_acceptS);
    static final short[] DFA5_special = DFA.unpackEncodedString(DFA5_specialS);
    static final short[][] DFA5_transition;

    static {
        int numStates = DFA5_transitionS.length;
        DFA5_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA5_transition[i] = DFA.unpackEncodedString(DFA5_transitionS[i]);
        }
    }

    class DFA5 extends DFA {

        public DFA5(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 5;
            this.eot = DFA5_eot;
            this.eof = DFA5_eof;
            this.min = DFA5_min;
            this.max = DFA5_max;
            this.accept = DFA5_accept;
            this.special = DFA5_special;
            this.transition = DFA5_transition;
        }
        public String getDescription() {
            return "639:21: ( 'Given' | 'When' | 'Then' | 'And' | 'Using' | 'Having' | 'GIVEN' | 'WHEN' | 'THEN' | 'AND' | 'USING' | 'HAVING' )";
        }
    }
    static final String DFA19_eotS =
        "\1\23\4\21\1\34\12\21\1\64\3\uffff\4\21\1\34\3\21\1\uffff\17\21\1\55\1\uffff\2\21\1\55\1\21\1\112\1\64\1\uffff\3\21\1\120\1\21\1\34\14\21\1\136\2\21\1\uffff\5\21\1\uffff\10\21\1\uffff\4\21\1\uffff\1\112\1\21\1\112\3\21\2\112\15\21\1\112\6\21\1\176\1\177\1\21\2\uffff\1\u0081\1\uffff";
    static final String DFA19_eofS =
        "\u0082\uffff";
    static final String DFA19_minS =
        "\1\0\1\103\1\105\1\116\1\55\1\0\1\111\2\110\1\116\1\123\1\101\3\0\1\55\1\0\3\uffff\2\105\1\124\1\104\1\0\1\60\2\55\1\uffff\1\166\1\126\1\145\1\105\1\145\1\105\1\144\1\104\1\151\1\111\1\166\1\126\1\0\1\42\2\0\1\uffff\1\42\2\0\1\60\2\0\1\uffff\1\116\1\120\1\101\1\0\1\56\1\0\1\145\1\105\1\156\1\116\1\156\1\116\2\11\1\156\1\116\1\151\1\111\3\0\1\uffff\1\60\1\55\1\101\2\55\1\uffff\2\55\1\156\1\116\4\11\1\uffff\1\147\1\107\1\156\1\116\1\uffff\1\0\1\55\1\0\1\122\2\104\2\0\4\11\1\147\1\107\2\60\1\111\1\105\1\101\2\11\1\0\1\117\1\106\1\124\2\72\1\101\2\0\1\72\2\uffff\1\0\1\uffff";
    static final String DFA19_maxS =
        "\1\uffff\1\124\1\105\1\116\1\71\1\uffff\1\151\2\150\1\156\1\163\1\141\3\uffff\1\71\1\uffff\3\uffff\2\105\1\124\1\104\1\uffff\3\71\1\uffff\1\166\1\126\1\145\1\105\1\145\1\105\1\144\1\104\1\151\1\111\1\166\1\126\1\uffff\1\165\2\uffff\1\uffff\1\165\2\uffff\1\71\2\uffff\1\uffff\1\116\1\120\1\101\1\uffff\1\71\1\uffff\1\145\1\105\1\156\1\116\1\156\1\116\2\40\1\156\1\116\1\151\1\111\3\uffff\1\uffff\2\71\1\101\2\55\1\uffff\2\71\1\156\1\116\4\40\1\uffff\1\147\1\107\1\156\1\116\1\uffff\1\uffff\1\71\1\uffff\1\122\2\104\2\uffff\4\40\1\147\1\107\2\71\1\111\1\105\1\101\2\40\1\uffff\1\117\1\106\1\124\2\72\1\101\2\uffff\1\72\2\uffff\1\uffff\1\uffff";
    static final String DFA19_acceptS =
        "\21\uffff\1\13\1\14\1\15\10\uffff\1\5\20\uffff\1\10\6\uffff\1\12\25\uffff\1\11\5\uffff\1\4\10\uffff\1\6\4\uffff\1\7\37\uffff\1\1\1\3\1\uffff\1\2";
    static final String DFA19_specialS =
        "\1\31\4\uffff\1\2\6\uffff\1\1\1\13\1\0\1\uffff\1\24\7\uffff\1\30\20\uffff\1\21\1\uffff\1\7\1\4\2\uffff\1\27\1\11\1\uffff\1\16\1\6\4\uffff\1\23\1\uffff\1\26\14\uffff\1\3\1\5\1\25\25\uffff\1\20\1\uffff\1\14\3\uffff\1\10\1\32\15\uffff\1\15\6\uffff\1\12\1\22\3\uffff\1\17\1\uffff}>";
    static final String[] DFA19_transitionS = {
            "\11\21\1\22\1\uffff\2\21\1\uffff\22\21\1\22\1\21\1\15\1\20\3\21\1\16\5\21\1\4\1\17\1\21\12\5\2\21\1\14\3\21\1\uffff\1\11\3\21\1\3\1\21\1\6\1\13\4\21\1\2\5\21\1\1\1\10\1\12\1\21\1\7\44\21\1\uffff\uff83\21",
            "\1\24\20\uffff\1\25",
            "\1\26",
            "\1\27",
            "\1\31\1\32\1\uffff\12\30",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\33\1\21\12\30\uffc6\21",
            "\1\36\37\uffff\1\35",
            "\1\40\37\uffff\1\37",
            "\1\42\37\uffff\1\41",
            "\1\44\37\uffff\1\43",
            "\1\46\37\uffff\1\45",
            "\1\50\37\uffff\1\47",
            "\11\51\2\uffff\2\51\1\uffff\22\51\1\uffff\35\51\1\uffff\uffc1\51",
            "\11\53\1\55\1\uffff\2\53\1\uffff\22\53\1\55\1\53\1\54\71\53\1\52\uffa3\53",
            "\11\57\1\55\1\uffff\2\57\1\uffff\22\57\1\55\6\57\1\60\64\57\1\56\uffa3\57",
            "\1\61\2\uffff\12\62",
            "\11\63\2\uffff\2\63\1\uffff\22\63\1\uffff\uffdf\63",
            "",
            "",
            "",
            "\1\65",
            "\1\66",
            "\1\67",
            "\1\70",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\33\1\21\12\30\uffc6\21",
            "\12\71",
            "\1\61\2\uffff\12\62",
            "\1\61\2\uffff\12\72",
            "",
            "\1\73",
            "\1\74",
            "\1\75",
            "\1\76",
            "\1\77",
            "\1\100",
            "\1\101",
            "\1\102",
            "\1\103",
            "\1\104",
            "\1\105",
            "\1\106",
            "\11\51\2\uffff\2\51\1\uffff\22\51\1\uffff\35\51\1\107\uffc1\51",
            "\1\110\4\uffff\1\110\64\uffff\1\110\5\uffff\1\110\3\uffff\1\110\7\uffff\1\110\3\uffff\1\110\1\uffff\2\110",
            "\11\53\1\55\1\uffff\2\53\1\uffff\22\53\1\55\1\53\1\54\71\53\1\52\uffa3\53",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "",
            "\1\111\4\uffff\1\111\64\uffff\1\111\5\uffff\1\111\3\uffff\1\111\7\uffff\1\111\3\uffff\1\111\1\uffff\2\111",
            "\11\57\1\55\1\uffff\2\57\1\uffff\22\57\1\55\6\57\1\60\64\57\1\56\uffa3\57",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "\12\62",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\113\1\21\12\62\13\21\1\114\37\21\1\114\uff9a\21",
            "\11\63\2\uffff\2\63\1\uffff\22\63\1\uffff\uffdf\63",
            "",
            "\1\115",
            "\1\116",
            "\1\117",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "\1\121\1\uffff\12\71",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\122\1\21\12\72\13\21\1\114\37\21\1\114\uff9a\21",
            "\1\123",
            "\1\124",
            "\1\125",
            "\1\126",
            "\1\127",
            "\1\130",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\132",
            "\1\133",
            "\1\134",
            "\1\135",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "\11\53\1\55\1\uffff\2\53\1\uffff\22\53\1\55\1\53\1\54\71\53\1\52\uffa3\53",
            "\11\57\1\55\1\uffff\2\57\1\uffff\22\57\1\55\6\57\1\60\64\57\1\56\uffa3\57",
            "",
            "\12\137",
            "\1\140\2\uffff\12\141",
            "\1\142",
            "\1\143",
            "\1\144",
            "",
            "\1\61\2\uffff\12\145",
            "\1\61\2\uffff\12\146",
            "\1\147",
            "\1\150",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "",
            "\1\151",
            "\1\152",
            "\1\153",
            "\1\154",
            "",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\17\21\12\137\13\21\1\114\37\21\1\114\uff9a\21",
            "\1\155\2\uffff\12\141",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\156\1\21\12\141\uffc6\21",
            "\1\157",
            "\1\160",
            "\1\161",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\122\1\21\12\145\13\21\1\114\37\21\1\114\uff9a\21",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\15\21\1\113\1\21\12\146\13\21\1\114\37\21\1\114\uff9a\21",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\1\162",
            "\1\163",
            "\12\141",
            "\12\164",
            "\1\165",
            "\1\166",
            "\1\167",
            "\1\131\26\uffff\1\131",
            "\1\131\26\uffff\1\131",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\17\21\12\164\uffc6\21",
            "\1\170",
            "\1\171",
            "\1\172",
            "\1\173",
            "\1\174",
            "\1\175",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            "\1\u0080",
            "",
            "",
            "\11\21\2\uffff\2\21\1\uffff\22\21\1\uffff\uffdf\21",
            ""
    };

    static final short[] DFA19_eot = DFA.unpackEncodedString(DFA19_eotS);
    static final short[] DFA19_eof = DFA.unpackEncodedString(DFA19_eofS);
    static final char[] DFA19_min = DFA.unpackEncodedStringToUnsignedChars(DFA19_minS);
    static final char[] DFA19_max = DFA.unpackEncodedStringToUnsignedChars(DFA19_maxS);
    static final short[] DFA19_accept = DFA.unpackEncodedString(DFA19_acceptS);
    static final short[] DFA19_special = DFA.unpackEncodedString(DFA19_specialS);
    static final short[][] DFA19_transition;

    static {
        int numStates = DFA19_transitionS.length;
        DFA19_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA19_transition[i] = DFA.unpackEncodedString(DFA19_transitionS[i]);
        }
    }

    class DFA19 extends DFA {

        public DFA19(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 19;
            this.eot = DFA19_eot;
            this.eof = DFA19_eof;
            this.min = DFA19_min;
            this.max = DFA19_max;
            this.accept = DFA19_accept;
            this.special = DFA19_special;
            this.transition = DFA19_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( T__14 | T__15 | T__16 | T__17 | RULE_INT | RULE_STEP_KEYWORD | RULE_PLACEHOLDER | RULE_STRING | RULE_NUMBER | RULE_SL_COMMENT | RULE_WORD | RULE_WS | RULE_EOL );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            IntStream input = _input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA19_14 = input.LA(1);

                        s = -1;
                        if ( (LA19_14=='\\') ) {s = 46;}

                        else if ( ((LA19_14>='\u0000' && LA19_14<='\b')||(LA19_14>='\u000B' && LA19_14<='\f')||(LA19_14>='\u000E' && LA19_14<='\u001F')||(LA19_14>='!' && LA19_14<='&')||(LA19_14>='(' && LA19_14<='[')||(LA19_14>=']' && LA19_14<='\uFFFF')) ) {s = 47;}

                        else if ( (LA19_14=='\'') ) {s = 48;}

                        else if ( (LA19_14=='\t'||LA19_14==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA19_12 = input.LA(1);

                        s = -1;
                        if ( ((LA19_12>='\u0000' && LA19_12<='\b')||(LA19_12>='\u000B' && LA19_12<='\f')||(LA19_12>='\u000E' && LA19_12<='\u001F')||(LA19_12>='!' && LA19_12<='=')||(LA19_12>='?' && LA19_12<='\uFFFF')) ) {s = 41;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA19_5 = input.LA(1);

                        s = -1;
                        if ( (LA19_5=='.') ) {s = 27;}

                        else if ( ((LA19_5>='0' && LA19_5<='9')) ) {s = 24;}

                        else if ( ((LA19_5>='\u0000' && LA19_5<='\b')||(LA19_5>='\u000B' && LA19_5<='\f')||(LA19_5>='\u000E' && LA19_5<='\u001F')||(LA19_5>='!' && LA19_5<='-')||LA19_5=='/'||(LA19_5>=':' && LA19_5<='\uFFFF')) ) {s = 17;}

                        else s = 28;

                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA19_71 = input.LA(1);

                        s = -1;
                        if ( ((LA19_71>='\u0000' && LA19_71<='\b')||(LA19_71>='\u000B' && LA19_71<='\f')||(LA19_71>='\u000E' && LA19_71<='\u001F')||(LA19_71>='!' && LA19_71<='\uFFFF')) ) {s = 17;}

                        else s = 94;

                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA19_44 = input.LA(1);

                        s = -1;
                        if ( ((LA19_44>='\u0000' && LA19_44<='\b')||(LA19_44>='\u000B' && LA19_44<='\f')||(LA19_44>='\u000E' && LA19_44<='\u001F')||(LA19_44>='!' && LA19_44<='\uFFFF')) ) {s = 17;}

                        else s = 45;

                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA19_72 = input.LA(1);

                        s = -1;
                        if ( (LA19_72=='\"') ) {s = 44;}

                        else if ( (LA19_72=='\\') ) {s = 42;}

                        else if ( ((LA19_72>='\u0000' && LA19_72<='\b')||(LA19_72>='\u000B' && LA19_72<='\f')||(LA19_72>='\u000E' && LA19_72<='\u001F')||LA19_72=='!'||(LA19_72>='#' && LA19_72<='[')||(LA19_72>=']' && LA19_72<='\uFFFF')) ) {s = 43;}

                        else if ( (LA19_72=='\t'||LA19_72==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA19_51 = input.LA(1);

                        s = -1;
                        if ( ((LA19_51>='\u0000' && LA19_51<='\b')||(LA19_51>='\u000B' && LA19_51<='\f')||(LA19_51>='\u000E' && LA19_51<='\u001F')||(LA19_51>='!' && LA19_51<='\uFFFF')) ) {s = 51;}

                        else s = 52;

                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA19_43 = input.LA(1);

                        s = -1;
                        if ( (LA19_43=='\"') ) {s = 44;}

                        else if ( (LA19_43=='\\') ) {s = 42;}

                        else if ( ((LA19_43>='\u0000' && LA19_43<='\b')||(LA19_43>='\u000B' && LA19_43<='\f')||(LA19_43>='\u000E' && LA19_43<='\u001F')||LA19_43=='!'||(LA19_43>='#' && LA19_43<='[')||(LA19_43>=']' && LA19_43<='\uFFFF')) ) {s = 43;}

                        else if ( (LA19_43=='\t'||LA19_43==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA19_101 = input.LA(1);

                        s = -1;
                        if ( (LA19_101=='.') ) {s = 82;}

                        else if ( (LA19_101=='E'||LA19_101=='e') ) {s = 76;}

                        else if ( ((LA19_101>='0' && LA19_101<='9')) ) {s = 101;}

                        else if ( ((LA19_101>='\u0000' && LA19_101<='\b')||(LA19_101>='\u000B' && LA19_101<='\f')||(LA19_101>='\u000E' && LA19_101<='\u001F')||(LA19_101>='!' && LA19_101<='-')||LA19_101=='/'||(LA19_101>=':' && LA19_101<='D')||(LA19_101>='F' && LA19_101<='d')||(LA19_101>='f' && LA19_101<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA19_48 = input.LA(1);

                        s = -1;
                        if ( ((LA19_48>='\u0000' && LA19_48<='\b')||(LA19_48>='\u000B' && LA19_48<='\f')||(LA19_48>='\u000E' && LA19_48<='\u001F')||(LA19_48>='!' && LA19_48<='\uFFFF')) ) {s = 17;}

                        else s = 45;

                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA19_123 = input.LA(1);

                        s = -1;
                        if ( ((LA19_123>='\u0000' && LA19_123<='\b')||(LA19_123>='\u000B' && LA19_123<='\f')||(LA19_123>='\u000E' && LA19_123<='\u001F')||(LA19_123>='!' && LA19_123<='\uFFFF')) ) {s = 17;}

                        else s = 126;

                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA19_13 = input.LA(1);

                        s = -1;
                        if ( (LA19_13=='\\') ) {s = 42;}

                        else if ( ((LA19_13>='\u0000' && LA19_13<='\b')||(LA19_13>='\u000B' && LA19_13<='\f')||(LA19_13>='\u000E' && LA19_13<='\u001F')||LA19_13=='!'||(LA19_13>='#' && LA19_13<='[')||(LA19_13>=']' && LA19_13<='\uFFFF')) ) {s = 43;}

                        else if ( (LA19_13=='\"') ) {s = 44;}

                        else if ( (LA19_13=='\t'||LA19_13==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA19_97 = input.LA(1);

                        s = -1;
                        if ( (LA19_97=='.') ) {s = 110;}

                        else if ( ((LA19_97>='0' && LA19_97<='9')) ) {s = 97;}

                        else if ( ((LA19_97>='\u0000' && LA19_97<='\b')||(LA19_97>='\u000B' && LA19_97<='\f')||(LA19_97>='\u000E' && LA19_97<='\u001F')||(LA19_97>='!' && LA19_97<='-')||LA19_97=='/'||(LA19_97>=':' && LA19_97<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA19_116 = input.LA(1);

                        s = -1;
                        if ( ((LA19_116>='0' && LA19_116<='9')) ) {s = 116;}

                        else if ( ((LA19_116>='\u0000' && LA19_116<='\b')||(LA19_116>='\u000B' && LA19_116<='\f')||(LA19_116>='\u000E' && LA19_116<='\u001F')||(LA19_116>='!' && LA19_116<='/')||(LA19_116>=':' && LA19_116<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA19_50 = input.LA(1);

                        s = -1;
                        if ( (LA19_50=='.') ) {s = 75;}

                        else if ( (LA19_50=='E'||LA19_50=='e') ) {s = 76;}

                        else if ( ((LA19_50>='0' && LA19_50<='9')) ) {s = 50;}

                        else if ( ((LA19_50>='\u0000' && LA19_50<='\b')||(LA19_50>='\u000B' && LA19_50<='\f')||(LA19_50>='\u000E' && LA19_50<='\u001F')||(LA19_50>='!' && LA19_50<='-')||LA19_50=='/'||(LA19_50>=':' && LA19_50<='D')||(LA19_50>='F' && LA19_50<='d')||(LA19_50>='f' && LA19_50<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA19_128 = input.LA(1);

                        s = -1;
                        if ( ((LA19_128>='\u0000' && LA19_128<='\b')||(LA19_128>='\u000B' && LA19_128<='\f')||(LA19_128>='\u000E' && LA19_128<='\u001F')||(LA19_128>='!' && LA19_128<='\uFFFF')) ) {s = 17;}

                        else s = 129;

                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA19_95 = input.LA(1);

                        s = -1;
                        if ( (LA19_95=='E'||LA19_95=='e') ) {s = 76;}

                        else if ( ((LA19_95>='0' && LA19_95<='9')) ) {s = 95;}

                        else if ( ((LA19_95>='\u0000' && LA19_95<='\b')||(LA19_95>='\u000B' && LA19_95<='\f')||(LA19_95>='\u000E' && LA19_95<='\u001F')||(LA19_95>='!' && LA19_95<='/')||(LA19_95>=':' && LA19_95<='D')||(LA19_95>='F' && LA19_95<='d')||(LA19_95>='f' && LA19_95<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA19_41 = input.LA(1);

                        s = -1;
                        if ( (LA19_41=='>') ) {s = 71;}

                        else if ( ((LA19_41>='\u0000' && LA19_41<='\b')||(LA19_41>='\u000B' && LA19_41<='\f')||(LA19_41>='\u000E' && LA19_41<='\u001F')||(LA19_41>='!' && LA19_41<='=')||(LA19_41>='?' && LA19_41<='\uFFFF')) ) {s = 41;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA19_124 = input.LA(1);

                        s = -1;
                        if ( ((LA19_124>='\u0000' && LA19_124<='\b')||(LA19_124>='\u000B' && LA19_124<='\f')||(LA19_124>='\u000E' && LA19_124<='\u001F')||(LA19_124>='!' && LA19_124<='\uFFFF')) ) {s = 17;}

                        else s = 127;

                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA19_56 = input.LA(1);

                        s = -1;
                        if ( ((LA19_56>='\u0000' && LA19_56<='\b')||(LA19_56>='\u000B' && LA19_56<='\f')||(LA19_56>='\u000E' && LA19_56<='\u001F')||(LA19_56>='!' && LA19_56<='\uFFFF')) ) {s = 17;}

                        else s = 80;

                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA19_16 = input.LA(1);

                        s = -1;
                        if ( ((LA19_16>='\u0000' && LA19_16<='\b')||(LA19_16>='\u000B' && LA19_16<='\f')||(LA19_16>='\u000E' && LA19_16<='\u001F')||(LA19_16>='!' && LA19_16<='\uFFFF')) ) {s = 51;}

                        else s = 52;

                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA19_73 = input.LA(1);

                        s = -1;
                        if ( (LA19_73=='\'') ) {s = 48;}

                        else if ( (LA19_73=='\\') ) {s = 46;}

                        else if ( ((LA19_73>='\u0000' && LA19_73<='\b')||(LA19_73>='\u000B' && LA19_73<='\f')||(LA19_73>='\u000E' && LA19_73<='\u001F')||(LA19_73>='!' && LA19_73<='&')||(LA19_73>='(' && LA19_73<='[')||(LA19_73>=']' && LA19_73<='\uFFFF')) ) {s = 47;}

                        else if ( (LA19_73=='\t'||LA19_73==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA19_58 = input.LA(1);

                        s = -1;
                        if ( ((LA19_58>='0' && LA19_58<='9')) ) {s = 58;}

                        else if ( (LA19_58=='.') ) {s = 82;}

                        else if ( (LA19_58=='E'||LA19_58=='e') ) {s = 76;}

                        else if ( ((LA19_58>='\u0000' && LA19_58<='\b')||(LA19_58>='\u000B' && LA19_58<='\f')||(LA19_58>='\u000E' && LA19_58<='\u001F')||(LA19_58>='!' && LA19_58<='-')||LA19_58=='/'||(LA19_58>=':' && LA19_58<='D')||(LA19_58>='F' && LA19_58<='d')||(LA19_58>='f' && LA19_58<='\uFFFF')) ) {s = 17;}

                        else s = 28;

                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA19_47 = input.LA(1);

                        s = -1;
                        if ( (LA19_47=='\'') ) {s = 48;}

                        else if ( (LA19_47=='\\') ) {s = 46;}

                        else if ( ((LA19_47>='\u0000' && LA19_47<='\b')||(LA19_47>='\u000B' && LA19_47<='\f')||(LA19_47>='\u000E' && LA19_47<='\u001F')||(LA19_47>='!' && LA19_47<='&')||(LA19_47>='(' && LA19_47<='[')||(LA19_47>=']' && LA19_47<='\uFFFF')) ) {s = 47;}

                        else if ( (LA19_47=='\t'||LA19_47==' ') ) {s = 45;}

                        else s = 17;

                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA19_24 = input.LA(1);

                        s = -1;
                        if ( (LA19_24=='.') ) {s = 27;}

                        else if ( ((LA19_24>='0' && LA19_24<='9')) ) {s = 24;}

                        else if ( ((LA19_24>='\u0000' && LA19_24<='\b')||(LA19_24>='\u000B' && LA19_24<='\f')||(LA19_24>='\u000E' && LA19_24<='\u001F')||(LA19_24>='!' && LA19_24<='-')||LA19_24=='/'||(LA19_24>=':' && LA19_24<='\uFFFF')) ) {s = 17;}

                        else s = 28;

                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA19_0 = input.LA(1);

                        s = -1;
                        if ( (LA19_0=='S') ) {s = 1;}

                        else if ( (LA19_0=='M') ) {s = 2;}

                        else if ( (LA19_0=='E') ) {s = 3;}

                        else if ( (LA19_0=='-') ) {s = 4;}

                        else if ( ((LA19_0>='0' && LA19_0<='9')) ) {s = 5;}

                        else if ( (LA19_0=='G') ) {s = 6;}

                        else if ( (LA19_0=='W') ) {s = 7;}

                        else if ( (LA19_0=='T') ) {s = 8;}

                        else if ( (LA19_0=='A') ) {s = 9;}

                        else if ( (LA19_0=='U') ) {s = 10;}

                        else if ( (LA19_0=='H') ) {s = 11;}

                        else if ( (LA19_0=='<') ) {s = 12;}

                        else if ( (LA19_0=='\"') ) {s = 13;}

                        else if ( (LA19_0=='\'') ) {s = 14;}

                        else if ( (LA19_0=='.') ) {s = 15;}

                        else if ( (LA19_0=='#') ) {s = 16;}

                        else if ( ((LA19_0>='\u0000' && LA19_0<='\b')||(LA19_0>='\u000B' && LA19_0<='\f')||(LA19_0>='\u000E' && LA19_0<='\u001F')||LA19_0=='!'||(LA19_0>='$' && LA19_0<='&')||(LA19_0>='(' && LA19_0<=',')||LA19_0=='/'||(LA19_0>=':' && LA19_0<=';')||(LA19_0>='=' && LA19_0<='?')||(LA19_0>='B' && LA19_0<='D')||LA19_0=='F'||(LA19_0>='I' && LA19_0<='L')||(LA19_0>='N' && LA19_0<='R')||LA19_0=='V'||(LA19_0>='X' && LA19_0<='{')||(LA19_0>='}' && LA19_0<='\uFFFF')) ) {s = 17;}

                        else if ( (LA19_0=='\t'||LA19_0==' ') ) {s = 18;}

                        else s = 19;

                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA19_102 = input.LA(1);

                        s = -1;
                        if ( (LA19_102=='E'||LA19_102=='e') ) {s = 76;}

                        else if ( ((LA19_102>='0' && LA19_102<='9')) ) {s = 102;}

                        else if ( (LA19_102=='.') ) {s = 75;}

                        else if ( ((LA19_102>='\u0000' && LA19_102<='\b')||(LA19_102>='\u000B' && LA19_102<='\f')||(LA19_102>='\u000E' && LA19_102<='\u001F')||(LA19_102>='!' && LA19_102<='-')||LA19_102=='/'||(LA19_102>=':' && LA19_102<='D')||(LA19_102>='F' && LA19_102<='d')||(LA19_102>='f' && LA19_102<='\uFFFF')) ) {s = 17;}

                        else s = 74;

                        if ( s>=0 ) return s;
                        break;
            }
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 19, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

}