package com.qmetry.qaf.bdd.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import com.qmetry.qaf.bdd.services.BddDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalBddDslParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_EOL", "RULE_STEP_KEYWORD", "RULE_WORD", "RULE_INT", "RULE_STRING", "RULE_PLACEHOLDER", "RULE_NUMBER", "RULE_NL", "RULE_SL_COMMENT", "RULE_WS", "'SCENARIO:'", "'META-DATA:'", "'STEP-DEF:'", "'END'"
    };
    public static final int RULE_EOL=4;
    public static final int RULE_WS=13;
    public static final int RULE_WORD=6;
    public static final int RULE_STRING=8;
    public static final int RULE_NUMBER=10;
    public static final int RULE_SL_COMMENT=12;
    public static final int T__15=15;
    public static final int RULE_PLACEHOLDER=9;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int RULE_STEP_KEYWORD=5;
    public static final int T__14=14;
    public static final int RULE_NL=11;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalBddDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalBddDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalBddDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalBddDsl.g"; }



     	private BddDslGrammarAccess grammarAccess;
     	
        public InternalBddDslParser(TokenStream input, BddDslGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Narrative";	
       	}
       	
       	@Override
       	protected BddDslGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleNarrative"
    // InternalBddDsl.g:67:1: entryRuleNarrative returns [EObject current=null] : iv_ruleNarrative= ruleNarrative EOF ;
    public final EObject entryRuleNarrative() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNarrative = null;


        try {
            // InternalBddDsl.g:68:2: (iv_ruleNarrative= ruleNarrative EOF )
            // InternalBddDsl.g:69:2: iv_ruleNarrative= ruleNarrative EOF
            {
             newCompositeNode(grammarAccess.getNarrativeRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleNarrative=ruleNarrative();

            state._fsp--;

             current =iv_ruleNarrative; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNarrative"


    // $ANTLR start "ruleNarrative"
    // InternalBddDsl.g:76:1: ruleNarrative returns [EObject current=null] : ( ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )* ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+ ) ;
    public final EObject ruleNarrative() throws RecognitionException {
        EObject current = null;

        Token lv_title_0_2=null;
        AntlrDatatypeRuleToken lv_title_0_1 = null;

        EObject lv_scenarios_1_1 = null;

        EObject lv_scenarios_1_2 = null;


         enterRule(); 
            
        try {
            // InternalBddDsl.g:79:28: ( ( ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )* ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+ ) )
            // InternalBddDsl.g:80:1: ( ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )* ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+ )
            {
            // InternalBddDsl.g:80:1: ( ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )* ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+ )
            // InternalBddDsl.g:80:2: ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )* ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+
            {
            // InternalBddDsl.g:80:2: ( ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==RULE_EOL||(LA2_0>=RULE_WORD && LA2_0<=RULE_PLACEHOLDER)) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalBddDsl.g:81:1: ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) )
            	    {
            	    // InternalBddDsl.g:81:1: ( (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL ) )
            	    // InternalBddDsl.g:82:1: (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL )
            	    {
            	    // InternalBddDsl.g:82:1: (lv_title_0_1= ruleTitle | lv_title_0_2= RULE_EOL )
            	    int alt1=2;
            	    int LA1_0 = input.LA(1);

            	    if ( ((LA1_0>=RULE_WORD && LA1_0<=RULE_PLACEHOLDER)) ) {
            	        alt1=1;
            	    }
            	    else if ( (LA1_0==RULE_EOL) ) {
            	        alt1=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 1, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt1) {
            	        case 1 :
            	            // InternalBddDsl.g:83:3: lv_title_0_1= ruleTitle
            	            {
            	             
            	            	        newCompositeNode(grammarAccess.getNarrativeAccess().getTitleTitleParserRuleCall_0_0_0()); 
            	            	    
            	            pushFollow(FOLLOW_3);
            	            lv_title_0_1=ruleTitle();

            	            state._fsp--;


            	            	        if (current==null) {
            	            	            current = createModelElementForParent(grammarAccess.getNarrativeRule());
            	            	        }
            	                   		set(
            	                   			current, 
            	                   			"title",
            	                    		lv_title_0_1, 
            	                    		"com.qmetry.qaf.bdd.BddDsl.Title");
            	            	        afterParserOrEnumRuleCall();
            	            	    

            	            }
            	            break;
            	        case 2 :
            	            // InternalBddDsl.g:98:8: lv_title_0_2= RULE_EOL
            	            {
            	            lv_title_0_2=(Token)match(input,RULE_EOL,FOLLOW_3); 

            	            			newLeafNode(lv_title_0_2, grammarAccess.getNarrativeAccess().getTitleEOLTerminalRuleCall_0_0_1()); 
            	            		

            	            	        if (current==null) {
            	            	            current = createModelElement(grammarAccess.getNarrativeRule());
            	            	        }
            	                   		setWithLastConsumed(
            	                   			current, 
            	                   			"title",
            	                    		lv_title_0_2, 
            	                    		"com.qmetry.qaf.bdd.BddDsl.EOL");
            	            	    

            	            }
            	            break;

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            // InternalBddDsl.g:116:3: ( ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) ) )+
            int cnt4=0;
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==14||LA4_0==16) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalBddDsl.g:117:1: ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) )
            	    {
            	    // InternalBddDsl.g:117:1: ( (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF ) )
            	    // InternalBddDsl.g:118:1: (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF )
            	    {
            	    // InternalBddDsl.g:118:1: (lv_scenarios_1_1= ruleSCENARIO | lv_scenarios_1_2= ruleSTEP_DEF )
            	    int alt3=2;
            	    int LA3_0 = input.LA(1);

            	    if ( (LA3_0==14) ) {
            	        alt3=1;
            	    }
            	    else if ( (LA3_0==16) ) {
            	        alt3=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 3, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt3) {
            	        case 1 :
            	            // InternalBddDsl.g:119:3: lv_scenarios_1_1= ruleSCENARIO
            	            {
            	             
            	            	        newCompositeNode(grammarAccess.getNarrativeAccess().getScenariosSCENARIOParserRuleCall_1_0_0()); 
            	            	    
            	            pushFollow(FOLLOW_4);
            	            lv_scenarios_1_1=ruleSCENARIO();

            	            state._fsp--;


            	            	        if (current==null) {
            	            	            current = createModelElementForParent(grammarAccess.getNarrativeRule());
            	            	        }
            	                   		add(
            	                   			current, 
            	                   			"scenarios",
            	                    		lv_scenarios_1_1, 
            	                    		"com.qmetry.qaf.bdd.BddDsl.SCENARIO");
            	            	        afterParserOrEnumRuleCall();
            	            	    

            	            }
            	            break;
            	        case 2 :
            	            // InternalBddDsl.g:134:8: lv_scenarios_1_2= ruleSTEP_DEF
            	            {
            	             
            	            	        newCompositeNode(grammarAccess.getNarrativeAccess().getScenariosSTEP_DEFParserRuleCall_1_0_1()); 
            	            	    
            	            pushFollow(FOLLOW_4);
            	            lv_scenarios_1_2=ruleSTEP_DEF();

            	            state._fsp--;


            	            	        if (current==null) {
            	            	            current = createModelElementForParent(grammarAccess.getNarrativeRule());
            	            	        }
            	                   		add(
            	                   			current, 
            	                   			"scenarios",
            	                    		lv_scenarios_1_2, 
            	                    		"com.qmetry.qaf.bdd.BddDsl.STEP_DEF");
            	            	        afterParserOrEnumRuleCall();
            	            	    

            	            }
            	            break;

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt4 >= 1 ) break loop4;
                        EarlyExitException eee =
                            new EarlyExitException(4, input);
                        throw eee;
                }
                cnt4++;
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNarrative"


    // $ANTLR start "entryRuleSCENARIO"
    // InternalBddDsl.g:160:1: entryRuleSCENARIO returns [EObject current=null] : iv_ruleSCENARIO= ruleSCENARIO EOF ;
    public final EObject entryRuleSCENARIO() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSCENARIO = null;


        try {
            // InternalBddDsl.g:161:2: (iv_ruleSCENARIO= ruleSCENARIO EOF )
            // InternalBddDsl.g:162:2: iv_ruleSCENARIO= ruleSCENARIO EOF
            {
             newCompositeNode(grammarAccess.getSCENARIORule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSCENARIO=ruleSCENARIO();

            state._fsp--;

             current =iv_ruleSCENARIO; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSCENARIO"


    // $ANTLR start "ruleSCENARIO"
    // InternalBddDsl.g:169:1: ruleSCENARIO returns [EObject current=null] : (otherlv_0= 'SCENARIO:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep ) )* ruleEND (this_EOL_8= RULE_EOL )* ) ;
    public final EObject ruleSCENARIO() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token this_EOL_2=null;
        Token otherlv_3=null;
        Token this_EOL_5=null;
        Token this_EOL_8=null;
        AntlrDatatypeRuleToken lv_title_1_0 = null;

        AntlrDatatypeRuleToken lv_description_4_0 = null;

        EObject lv_steps_6_0 = null;


         enterRule(); 
            
        try {
            // InternalBddDsl.g:172:28: ( (otherlv_0= 'SCENARIO:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep ) )* ruleEND (this_EOL_8= RULE_EOL )* ) )
            // InternalBddDsl.g:173:1: (otherlv_0= 'SCENARIO:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep ) )* ruleEND (this_EOL_8= RULE_EOL )* )
            {
            // InternalBddDsl.g:173:1: (otherlv_0= 'SCENARIO:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep ) )* ruleEND (this_EOL_8= RULE_EOL )* )
            // InternalBddDsl.g:173:3: otherlv_0= 'SCENARIO:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep ) )* ruleEND (this_EOL_8= RULE_EOL )*
            {
            otherlv_0=(Token)match(input,14,FOLLOW_5); 

                	newLeafNode(otherlv_0, grammarAccess.getSCENARIOAccess().getSCENARIOKeyword_0());
                
            // InternalBddDsl.g:177:1: ( (lv_title_1_0= ruleTitle ) )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( ((LA5_0>=RULE_WORD && LA5_0<=RULE_PLACEHOLDER)) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalBddDsl.g:178:1: (lv_title_1_0= ruleTitle )
                    {
                    // InternalBddDsl.g:178:1: (lv_title_1_0= ruleTitle )
                    // InternalBddDsl.g:179:3: lv_title_1_0= ruleTitle
                    {
                     
                    	        newCompositeNode(grammarAccess.getSCENARIOAccess().getTitleTitleParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_title_1_0=ruleTitle();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSCENARIORule());
                    	        }
                           		set(
                           			current, 
                           			"title",
                            		lv_title_1_0, 
                            		"com.qmetry.qaf.bdd.BddDsl.Title");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            this_EOL_2=(Token)match(input,RULE_EOL,FOLLOW_7); 
             
                newLeafNode(this_EOL_2, grammarAccess.getSCENARIOAccess().getEOLTerminalRuleCall_2()); 
                
            otherlv_3=(Token)match(input,15,FOLLOW_5); 

                	newLeafNode(otherlv_3, grammarAccess.getSCENARIOAccess().getMETADATAKeyword_3());
                
            // InternalBddDsl.g:203:1: ( (lv_description_4_0= ruleTitle ) )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( ((LA6_0>=RULE_WORD && LA6_0<=RULE_PLACEHOLDER)) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalBddDsl.g:204:1: (lv_description_4_0= ruleTitle )
                    {
                    // InternalBddDsl.g:204:1: (lv_description_4_0= ruleTitle )
                    // InternalBddDsl.g:205:3: lv_description_4_0= ruleTitle
                    {
                     
                    	        newCompositeNode(grammarAccess.getSCENARIOAccess().getDescriptionTitleParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_description_4_0=ruleTitle();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSCENARIORule());
                    	        }
                           		set(
                           			current, 
                           			"description",
                            		lv_description_4_0, 
                            		"com.qmetry.qaf.bdd.BddDsl.Title");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalBddDsl.g:221:3: (this_EOL_5= RULE_EOL )+
            int cnt7=0;
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==RULE_EOL) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalBddDsl.g:221:4: this_EOL_5= RULE_EOL
            	    {
            	    this_EOL_5=(Token)match(input,RULE_EOL,FOLLOW_8); 
            	     
            	        newLeafNode(this_EOL_5, grammarAccess.getSCENARIOAccess().getEOLTerminalRuleCall_5()); 
            	        

            	    }
            	    break;

            	default :
            	    if ( cnt7 >= 1 ) break loop7;
                        EarlyExitException eee =
                            new EarlyExitException(7, input);
                        throw eee;
                }
                cnt7++;
            } while (true);

            // InternalBddDsl.g:225:3: ( (lv_steps_6_0= ruleStep ) )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==RULE_STEP_KEYWORD) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalBddDsl.g:226:1: (lv_steps_6_0= ruleStep )
            	    {
            	    // InternalBddDsl.g:226:1: (lv_steps_6_0= ruleStep )
            	    // InternalBddDsl.g:227:3: lv_steps_6_0= ruleStep
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSCENARIOAccess().getStepsStepParserRuleCall_6_0()); 
            	    	    
            	    pushFollow(FOLLOW_9);
            	    lv_steps_6_0=ruleStep();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSCENARIORule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"steps",
            	            		lv_steps_6_0, 
            	            		"com.qmetry.qaf.bdd.BddDsl.Step");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

             
                    newCompositeNode(grammarAccess.getSCENARIOAccess().getENDParserRuleCall_7()); 
                
            pushFollow(FOLLOW_10);
            ruleEND();

            state._fsp--;

             
                    afterParserOrEnumRuleCall();
                
            // InternalBddDsl.g:251:1: (this_EOL_8= RULE_EOL )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==RULE_EOL) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // InternalBddDsl.g:251:2: this_EOL_8= RULE_EOL
            	    {
            	    this_EOL_8=(Token)match(input,RULE_EOL,FOLLOW_10); 
            	     
            	        newLeafNode(this_EOL_8, grammarAccess.getSCENARIOAccess().getEOLTerminalRuleCall_8()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSCENARIO"


    // $ANTLR start "entryRuleSTEP_DEF"
    // InternalBddDsl.g:263:1: entryRuleSTEP_DEF returns [EObject current=null] : iv_ruleSTEP_DEF= ruleSTEP_DEF EOF ;
    public final EObject entryRuleSTEP_DEF() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSTEP_DEF = null;


        try {
            // InternalBddDsl.g:264:2: (iv_ruleSTEP_DEF= ruleSTEP_DEF EOF )
            // InternalBddDsl.g:265:2: iv_ruleSTEP_DEF= ruleSTEP_DEF EOF
            {
             newCompositeNode(grammarAccess.getSTEP_DEFRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSTEP_DEF=ruleSTEP_DEF();

            state._fsp--;

             current =iv_ruleSTEP_DEF; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSTEP_DEF"


    // $ANTLR start "ruleSTEP_DEF"
    // InternalBddDsl.g:272:1: ruleSTEP_DEF returns [EObject current=null] : (otherlv_0= 'STEP-DEF:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep2 ) )* ruleEND (this_EOL_8= RULE_EOL )? ) ;
    public final EObject ruleSTEP_DEF() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token this_EOL_2=null;
        Token otherlv_3=null;
        Token this_EOL_5=null;
        Token this_EOL_8=null;
        AntlrDatatypeRuleToken lv_title_1_0 = null;

        AntlrDatatypeRuleToken lv_description_4_0 = null;

        EObject lv_steps_6_0 = null;


         enterRule(); 
            
        try {
            // InternalBddDsl.g:275:28: ( (otherlv_0= 'STEP-DEF:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep2 ) )* ruleEND (this_EOL_8= RULE_EOL )? ) )
            // InternalBddDsl.g:276:1: (otherlv_0= 'STEP-DEF:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep2 ) )* ruleEND (this_EOL_8= RULE_EOL )? )
            {
            // InternalBddDsl.g:276:1: (otherlv_0= 'STEP-DEF:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep2 ) )* ruleEND (this_EOL_8= RULE_EOL )? )
            // InternalBddDsl.g:276:3: otherlv_0= 'STEP-DEF:' ( (lv_title_1_0= ruleTitle ) )? this_EOL_2= RULE_EOL otherlv_3= 'META-DATA:' ( (lv_description_4_0= ruleTitle ) )? (this_EOL_5= RULE_EOL )+ ( (lv_steps_6_0= ruleStep2 ) )* ruleEND (this_EOL_8= RULE_EOL )?
            {
            otherlv_0=(Token)match(input,16,FOLLOW_5); 

                	newLeafNode(otherlv_0, grammarAccess.getSTEP_DEFAccess().getSTEPDEFKeyword_0());
                
            // InternalBddDsl.g:280:1: ( (lv_title_1_0= ruleTitle ) )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( ((LA10_0>=RULE_WORD && LA10_0<=RULE_PLACEHOLDER)) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // InternalBddDsl.g:281:1: (lv_title_1_0= ruleTitle )
                    {
                    // InternalBddDsl.g:281:1: (lv_title_1_0= ruleTitle )
                    // InternalBddDsl.g:282:3: lv_title_1_0= ruleTitle
                    {
                     
                    	        newCompositeNode(grammarAccess.getSTEP_DEFAccess().getTitleTitleParserRuleCall_1_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_title_1_0=ruleTitle();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSTEP_DEFRule());
                    	        }
                           		set(
                           			current, 
                           			"title",
                            		lv_title_1_0, 
                            		"com.qmetry.qaf.bdd.BddDsl.Title");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            this_EOL_2=(Token)match(input,RULE_EOL,FOLLOW_7); 
             
                newLeafNode(this_EOL_2, grammarAccess.getSTEP_DEFAccess().getEOLTerminalRuleCall_2()); 
                
            otherlv_3=(Token)match(input,15,FOLLOW_5); 

                	newLeafNode(otherlv_3, grammarAccess.getSTEP_DEFAccess().getMETADATAKeyword_3());
                
            // InternalBddDsl.g:306:1: ( (lv_description_4_0= ruleTitle ) )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( ((LA11_0>=RULE_WORD && LA11_0<=RULE_PLACEHOLDER)) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // InternalBddDsl.g:307:1: (lv_description_4_0= ruleTitle )
                    {
                    // InternalBddDsl.g:307:1: (lv_description_4_0= ruleTitle )
                    // InternalBddDsl.g:308:3: lv_description_4_0= ruleTitle
                    {
                     
                    	        newCompositeNode(grammarAccess.getSTEP_DEFAccess().getDescriptionTitleParserRuleCall_4_0()); 
                    	    
                    pushFollow(FOLLOW_6);
                    lv_description_4_0=ruleTitle();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSTEP_DEFRule());
                    	        }
                           		set(
                           			current, 
                           			"description",
                            		lv_description_4_0, 
                            		"com.qmetry.qaf.bdd.BddDsl.Title");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }
                    break;

            }

            // InternalBddDsl.g:324:3: (this_EOL_5= RULE_EOL )+
            int cnt12=0;
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==RULE_EOL) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalBddDsl.g:324:4: this_EOL_5= RULE_EOL
            	    {
            	    this_EOL_5=(Token)match(input,RULE_EOL,FOLLOW_11); 
            	     
            	        newLeafNode(this_EOL_5, grammarAccess.getSTEP_DEFAccess().getEOLTerminalRuleCall_5()); 
            	        

            	    }
            	    break;

            	default :
            	    if ( cnt12 >= 1 ) break loop12;
                        EarlyExitException eee =
                            new EarlyExitException(12, input);
                        throw eee;
                }
                cnt12++;
            } while (true);

            // InternalBddDsl.g:328:3: ( (lv_steps_6_0= ruleStep2 ) )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( ((LA13_0>=RULE_STEP_KEYWORD && LA13_0<=RULE_PLACEHOLDER)) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // InternalBddDsl.g:329:1: (lv_steps_6_0= ruleStep2 )
            	    {
            	    // InternalBddDsl.g:329:1: (lv_steps_6_0= ruleStep2 )
            	    // InternalBddDsl.g:330:3: lv_steps_6_0= ruleStep2
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSTEP_DEFAccess().getStepsStep2ParserRuleCall_6_0()); 
            	    	    
            	    pushFollow(FOLLOW_12);
            	    lv_steps_6_0=ruleStep2();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSTEP_DEFRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"steps",
            	            		lv_steps_6_0, 
            	            		"com.qmetry.qaf.bdd.BddDsl.Step2");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

             
                    newCompositeNode(grammarAccess.getSTEP_DEFAccess().getENDParserRuleCall_7()); 
                
            pushFollow(FOLLOW_10);
            ruleEND();

            state._fsp--;

             
                    afterParserOrEnumRuleCall();
                
            // InternalBddDsl.g:354:1: (this_EOL_8= RULE_EOL )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==RULE_EOL) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // InternalBddDsl.g:354:2: this_EOL_8= RULE_EOL
                    {
                    this_EOL_8=(Token)match(input,RULE_EOL,FOLLOW_2); 
                     
                        newLeafNode(this_EOL_8, grammarAccess.getSTEP_DEFAccess().getEOLTerminalRuleCall_8()); 
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSTEP_DEF"


    // $ANTLR start "entryRuleEND"
    // InternalBddDsl.g:366:1: entryRuleEND returns [String current=null] : iv_ruleEND= ruleEND EOF ;
    public final String entryRuleEND() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEND = null;


        try {
            // InternalBddDsl.g:367:2: (iv_ruleEND= ruleEND EOF )
            // InternalBddDsl.g:368:2: iv_ruleEND= ruleEND EOF
            {
             newCompositeNode(grammarAccess.getENDRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEND=ruleEND();

            state._fsp--;

             current =iv_ruleEND.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEND"


    // $ANTLR start "ruleEND"
    // InternalBddDsl.g:375:1: ruleEND returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : kw= 'END' ;
    public final AntlrDatatypeRuleToken ruleEND() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;

         enterRule(); 
            
        try {
            // InternalBddDsl.g:378:28: (kw= 'END' )
            // InternalBddDsl.g:380:2: kw= 'END'
            {
            kw=(Token)match(input,17,FOLLOW_2); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getENDAccess().getENDKeyword()); 
                

            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEND"


    // $ANTLR start "entryRuleStep"
    // InternalBddDsl.g:393:1: entryRuleStep returns [EObject current=null] : iv_ruleStep= ruleStep EOF ;
    public final EObject entryRuleStep() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStep = null;


        try {
            // InternalBddDsl.g:394:2: (iv_ruleStep= ruleStep EOF )
            // InternalBddDsl.g:395:2: iv_ruleStep= ruleStep EOF
            {
             newCompositeNode(grammarAccess.getStepRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStep=ruleStep();

            state._fsp--;

             current =iv_ruleStep; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStep"


    // $ANTLR start "ruleStep"
    // InternalBddDsl.g:402:1: ruleStep returns [EObject current=null] : (this_STEP_KEYWORD_0= RULE_STEP_KEYWORD ( (lv_description_1_0= ruleStepDescription ) ) (this_EOL_2= RULE_EOL )* ) ;
    public final EObject ruleStep() throws RecognitionException {
        EObject current = null;

        Token this_STEP_KEYWORD_0=null;
        Token this_EOL_2=null;
        AntlrDatatypeRuleToken lv_description_1_0 = null;


         enterRule(); 
            
        try {
            // InternalBddDsl.g:405:28: ( (this_STEP_KEYWORD_0= RULE_STEP_KEYWORD ( (lv_description_1_0= ruleStepDescription ) ) (this_EOL_2= RULE_EOL )* ) )
            // InternalBddDsl.g:406:1: (this_STEP_KEYWORD_0= RULE_STEP_KEYWORD ( (lv_description_1_0= ruleStepDescription ) ) (this_EOL_2= RULE_EOL )* )
            {
            // InternalBddDsl.g:406:1: (this_STEP_KEYWORD_0= RULE_STEP_KEYWORD ( (lv_description_1_0= ruleStepDescription ) ) (this_EOL_2= RULE_EOL )* )
            // InternalBddDsl.g:406:2: this_STEP_KEYWORD_0= RULE_STEP_KEYWORD ( (lv_description_1_0= ruleStepDescription ) ) (this_EOL_2= RULE_EOL )*
            {
            this_STEP_KEYWORD_0=(Token)match(input,RULE_STEP_KEYWORD,FOLLOW_13); 
             
                newLeafNode(this_STEP_KEYWORD_0, grammarAccess.getStepAccess().getSTEP_KEYWORDTerminalRuleCall_0()); 
                
            // InternalBddDsl.g:410:1: ( (lv_description_1_0= ruleStepDescription ) )
            // InternalBddDsl.g:411:1: (lv_description_1_0= ruleStepDescription )
            {
            // InternalBddDsl.g:411:1: (lv_description_1_0= ruleStepDescription )
            // InternalBddDsl.g:412:3: lv_description_1_0= ruleStepDescription
            {
             
            	        newCompositeNode(grammarAccess.getStepAccess().getDescriptionStepDescriptionParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_10);
            lv_description_1_0=ruleStepDescription();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getStepRule());
            	        }
                   		set(
                   			current, 
                   			"description",
                    		lv_description_1_0, 
                    		"com.qmetry.qaf.bdd.BddDsl.StepDescription");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalBddDsl.g:428:2: (this_EOL_2= RULE_EOL )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==RULE_EOL) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // InternalBddDsl.g:428:3: this_EOL_2= RULE_EOL
            	    {
            	    this_EOL_2=(Token)match(input,RULE_EOL,FOLLOW_10); 
            	     
            	        newLeafNode(this_EOL_2, grammarAccess.getStepAccess().getEOLTerminalRuleCall_2()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStep"


    // $ANTLR start "entryRuleStep2"
    // InternalBddDsl.g:440:1: entryRuleStep2 returns [EObject current=null] : iv_ruleStep2= ruleStep2 EOF ;
    public final EObject entryRuleStep2() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStep2 = null;


        try {
            // InternalBddDsl.g:441:2: (iv_ruleStep2= ruleStep2 EOF )
            // InternalBddDsl.g:442:2: iv_ruleStep2= ruleStep2 EOF
            {
             newCompositeNode(grammarAccess.getStep2Rule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStep2=ruleStep2();

            state._fsp--;

             current =iv_ruleStep2; 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStep2"


    // $ANTLR start "ruleStep2"
    // InternalBddDsl.g:449:1: ruleStep2 returns [EObject current=null] : ( ( (lv_description_0_0= ruleStepDescription ) ) (this_EOL_1= RULE_EOL )* ) ;
    public final EObject ruleStep2() throws RecognitionException {
        EObject current = null;

        Token this_EOL_1=null;
        AntlrDatatypeRuleToken lv_description_0_0 = null;


         enterRule(); 
            
        try {
            // InternalBddDsl.g:452:28: ( ( ( (lv_description_0_0= ruleStepDescription ) ) (this_EOL_1= RULE_EOL )* ) )
            // InternalBddDsl.g:453:1: ( ( (lv_description_0_0= ruleStepDescription ) ) (this_EOL_1= RULE_EOL )* )
            {
            // InternalBddDsl.g:453:1: ( ( (lv_description_0_0= ruleStepDescription ) ) (this_EOL_1= RULE_EOL )* )
            // InternalBddDsl.g:453:2: ( (lv_description_0_0= ruleStepDescription ) ) (this_EOL_1= RULE_EOL )*
            {
            // InternalBddDsl.g:453:2: ( (lv_description_0_0= ruleStepDescription ) )
            // InternalBddDsl.g:454:1: (lv_description_0_0= ruleStepDescription )
            {
            // InternalBddDsl.g:454:1: (lv_description_0_0= ruleStepDescription )
            // InternalBddDsl.g:455:3: lv_description_0_0= ruleStepDescription
            {
             
            	        newCompositeNode(grammarAccess.getStep2Access().getDescriptionStepDescriptionParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_10);
            lv_description_0_0=ruleStepDescription();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getStep2Rule());
            	        }
                   		set(
                   			current, 
                   			"description",
                    		lv_description_0_0, 
                    		"com.qmetry.qaf.bdd.BddDsl.StepDescription");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // InternalBddDsl.g:471:2: (this_EOL_1= RULE_EOL )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==RULE_EOL) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // InternalBddDsl.g:471:3: this_EOL_1= RULE_EOL
            	    {
            	    this_EOL_1=(Token)match(input,RULE_EOL,FOLLOW_10); 
            	     
            	        newLeafNode(this_EOL_1, grammarAccess.getStep2Access().getEOLTerminalRuleCall_1()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStep2"


    // $ANTLR start "entryRuleTitle"
    // InternalBddDsl.g:487:1: entryRuleTitle returns [String current=null] : iv_ruleTitle= ruleTitle EOF ;
    public final String entryRuleTitle() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleTitle = null;


        try {
            // InternalBddDsl.g:488:2: (iv_ruleTitle= ruleTitle EOF )
            // InternalBddDsl.g:489:2: iv_ruleTitle= ruleTitle EOF
            {
             newCompositeNode(grammarAccess.getTitleRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTitle=ruleTitle();

            state._fsp--;

             current =iv_ruleTitle.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTitle"


    // $ANTLR start "ruleTitle"
    // InternalBddDsl.g:496:1: ruleTitle returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : ( (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER ) (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )* ) ;
    public final AntlrDatatypeRuleToken ruleTitle() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_WORD_0=null;
        Token this_INT_1=null;
        Token this_STRING_2=null;
        Token this_PLACEHOLDER_3=null;
        Token this_WORD_4=null;
        Token this_INT_5=null;
        Token this_STRING_6=null;
        Token this_PLACEHOLDER_7=null;
        Token this_STEP_KEYWORD_8=null;

         enterRule(); 
            
        try {
            // InternalBddDsl.g:499:28: ( ( (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER ) (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )* ) )
            // InternalBddDsl.g:500:1: ( (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER ) (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )* )
            {
            // InternalBddDsl.g:500:1: ( (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER ) (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )* )
            // InternalBddDsl.g:500:2: (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER ) (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )*
            {
            // InternalBddDsl.g:500:2: (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER )
            int alt17=4;
            switch ( input.LA(1) ) {
            case RULE_WORD:
                {
                alt17=1;
                }
                break;
            case RULE_INT:
                {
                alt17=2;
                }
                break;
            case RULE_STRING:
                {
                alt17=3;
                }
                break;
            case RULE_PLACEHOLDER:
                {
                alt17=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // InternalBddDsl.g:500:7: this_WORD_0= RULE_WORD
                    {
                    this_WORD_0=(Token)match(input,RULE_WORD,FOLLOW_14); 

                    		current.merge(this_WORD_0);
                        
                     
                        newLeafNode(this_WORD_0, grammarAccess.getTitleAccess().getWORDTerminalRuleCall_0_0()); 
                        

                    }
                    break;
                case 2 :
                    // InternalBddDsl.g:508:10: this_INT_1= RULE_INT
                    {
                    this_INT_1=(Token)match(input,RULE_INT,FOLLOW_14); 

                    		current.merge(this_INT_1);
                        
                     
                        newLeafNode(this_INT_1, grammarAccess.getTitleAccess().getINTTerminalRuleCall_0_1()); 
                        

                    }
                    break;
                case 3 :
                    // InternalBddDsl.g:516:10: this_STRING_2= RULE_STRING
                    {
                    this_STRING_2=(Token)match(input,RULE_STRING,FOLLOW_14); 

                    		current.merge(this_STRING_2);
                        
                     
                        newLeafNode(this_STRING_2, grammarAccess.getTitleAccess().getSTRINGTerminalRuleCall_0_2()); 
                        

                    }
                    break;
                case 4 :
                    // InternalBddDsl.g:524:10: this_PLACEHOLDER_3= RULE_PLACEHOLDER
                    {
                    this_PLACEHOLDER_3=(Token)match(input,RULE_PLACEHOLDER,FOLLOW_14); 

                    		current.merge(this_PLACEHOLDER_3);
                        
                     
                        newLeafNode(this_PLACEHOLDER_3, grammarAccess.getTitleAccess().getPLACEHOLDERTerminalRuleCall_0_3()); 
                        

                    }
                    break;

            }

            // InternalBddDsl.g:531:2: (this_WORD_4= RULE_WORD | this_INT_5= RULE_INT | this_STRING_6= RULE_STRING | this_PLACEHOLDER_7= RULE_PLACEHOLDER | this_STEP_KEYWORD_8= RULE_STEP_KEYWORD )*
            loop18:
            do {
                int alt18=6;
                switch ( input.LA(1) ) {
                case RULE_WORD:
                    {
                    alt18=1;
                    }
                    break;
                case RULE_INT:
                    {
                    alt18=2;
                    }
                    break;
                case RULE_STRING:
                    {
                    alt18=3;
                    }
                    break;
                case RULE_PLACEHOLDER:
                    {
                    alt18=4;
                    }
                    break;
                case RULE_STEP_KEYWORD:
                    {
                    alt18=5;
                    }
                    break;

                }

                switch (alt18) {
            	case 1 :
            	    // InternalBddDsl.g:531:7: this_WORD_4= RULE_WORD
            	    {
            	    this_WORD_4=(Token)match(input,RULE_WORD,FOLLOW_14); 

            	    		current.merge(this_WORD_4);
            	        
            	     
            	        newLeafNode(this_WORD_4, grammarAccess.getTitleAccess().getWORDTerminalRuleCall_1_0()); 
            	        

            	    }
            	    break;
            	case 2 :
            	    // InternalBddDsl.g:539:10: this_INT_5= RULE_INT
            	    {
            	    this_INT_5=(Token)match(input,RULE_INT,FOLLOW_14); 

            	    		current.merge(this_INT_5);
            	        
            	     
            	        newLeafNode(this_INT_5, grammarAccess.getTitleAccess().getINTTerminalRuleCall_1_1()); 
            	        

            	    }
            	    break;
            	case 3 :
            	    // InternalBddDsl.g:547:10: this_STRING_6= RULE_STRING
            	    {
            	    this_STRING_6=(Token)match(input,RULE_STRING,FOLLOW_14); 

            	    		current.merge(this_STRING_6);
            	        
            	     
            	        newLeafNode(this_STRING_6, grammarAccess.getTitleAccess().getSTRINGTerminalRuleCall_1_2()); 
            	        

            	    }
            	    break;
            	case 4 :
            	    // InternalBddDsl.g:555:10: this_PLACEHOLDER_7= RULE_PLACEHOLDER
            	    {
            	    this_PLACEHOLDER_7=(Token)match(input,RULE_PLACEHOLDER,FOLLOW_14); 

            	    		current.merge(this_PLACEHOLDER_7);
            	        
            	     
            	        newLeafNode(this_PLACEHOLDER_7, grammarAccess.getTitleAccess().getPLACEHOLDERTerminalRuleCall_1_3()); 
            	        

            	    }
            	    break;
            	case 5 :
            	    // InternalBddDsl.g:563:10: this_STEP_KEYWORD_8= RULE_STEP_KEYWORD
            	    {
            	    this_STEP_KEYWORD_8=(Token)match(input,RULE_STEP_KEYWORD,FOLLOW_14); 

            	    		current.merge(this_STEP_KEYWORD_8);
            	        
            	     
            	        newLeafNode(this_STEP_KEYWORD_8, grammarAccess.getTitleAccess().getSTEP_KEYWORDTerminalRuleCall_1_4()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTitle"


    // $ANTLR start "entryRuleStepDescription"
    // InternalBddDsl.g:578:1: entryRuleStepDescription returns [String current=null] : iv_ruleStepDescription= ruleStepDescription EOF ;
    public final String entryRuleStepDescription() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleStepDescription = null;


        try {
            // InternalBddDsl.g:579:2: (iv_ruleStepDescription= ruleStepDescription EOF )
            // InternalBddDsl.g:580:2: iv_ruleStepDescription= ruleStepDescription EOF
            {
             newCompositeNode(grammarAccess.getStepDescriptionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStepDescription=ruleStepDescription();

            state._fsp--;

             current =iv_ruleStepDescription.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStepDescription"


    // $ANTLR start "ruleStepDescription"
    // InternalBddDsl.g:587:1: ruleStepDescription returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER | this_STEP_KEYWORD_4= RULE_STEP_KEYWORD )+ ;
    public final AntlrDatatypeRuleToken ruleStepDescription() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_WORD_0=null;
        Token this_INT_1=null;
        Token this_STRING_2=null;
        Token this_PLACEHOLDER_3=null;
        Token this_STEP_KEYWORD_4=null;

         enterRule(); 
            
        try {
            // InternalBddDsl.g:590:28: ( (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER | this_STEP_KEYWORD_4= RULE_STEP_KEYWORD )+ )
            // InternalBddDsl.g:591:1: (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER | this_STEP_KEYWORD_4= RULE_STEP_KEYWORD )+
            {
            // InternalBddDsl.g:591:1: (this_WORD_0= RULE_WORD | this_INT_1= RULE_INT | this_STRING_2= RULE_STRING | this_PLACEHOLDER_3= RULE_PLACEHOLDER | this_STEP_KEYWORD_4= RULE_STEP_KEYWORD )+
            int cnt19=0;
            loop19:
            do {
                int alt19=6;
                switch ( input.LA(1) ) {
                case RULE_STEP_KEYWORD:
                    {
                    alt19=5;
                    }
                    break;
                case RULE_WORD:
                    {
                    alt19=1;
                    }
                    break;
                case RULE_INT:
                    {
                    alt19=2;
                    }
                    break;
                case RULE_STRING:
                    {
                    alt19=3;
                    }
                    break;
                case RULE_PLACEHOLDER:
                    {
                    alt19=4;
                    }
                    break;

                }

                switch (alt19) {
            	case 1 :
            	    // InternalBddDsl.g:591:6: this_WORD_0= RULE_WORD
            	    {
            	    this_WORD_0=(Token)match(input,RULE_WORD,FOLLOW_14); 

            	    		current.merge(this_WORD_0);
            	        
            	     
            	        newLeafNode(this_WORD_0, grammarAccess.getStepDescriptionAccess().getWORDTerminalRuleCall_0()); 
            	        

            	    }
            	    break;
            	case 2 :
            	    // InternalBddDsl.g:599:10: this_INT_1= RULE_INT
            	    {
            	    this_INT_1=(Token)match(input,RULE_INT,FOLLOW_14); 

            	    		current.merge(this_INT_1);
            	        
            	     
            	        newLeafNode(this_INT_1, grammarAccess.getStepDescriptionAccess().getINTTerminalRuleCall_1()); 
            	        

            	    }
            	    break;
            	case 3 :
            	    // InternalBddDsl.g:607:10: this_STRING_2= RULE_STRING
            	    {
            	    this_STRING_2=(Token)match(input,RULE_STRING,FOLLOW_14); 

            	    		current.merge(this_STRING_2);
            	        
            	     
            	        newLeafNode(this_STRING_2, grammarAccess.getStepDescriptionAccess().getSTRINGTerminalRuleCall_2()); 
            	        

            	    }
            	    break;
            	case 4 :
            	    // InternalBddDsl.g:615:10: this_PLACEHOLDER_3= RULE_PLACEHOLDER
            	    {
            	    this_PLACEHOLDER_3=(Token)match(input,RULE_PLACEHOLDER,FOLLOW_14); 

            	    		current.merge(this_PLACEHOLDER_3);
            	        
            	     
            	        newLeafNode(this_PLACEHOLDER_3, grammarAccess.getStepDescriptionAccess().getPLACEHOLDERTerminalRuleCall_3()); 
            	        

            	    }
            	    break;
            	case 5 :
            	    // InternalBddDsl.g:623:10: this_STEP_KEYWORD_4= RULE_STEP_KEYWORD
            	    {
            	    this_STEP_KEYWORD_4=(Token)match(input,RULE_STEP_KEYWORD,FOLLOW_14); 

            	    		current.merge(this_STEP_KEYWORD_4);
            	        
            	     
            	        newLeafNode(this_STEP_KEYWORD_4, grammarAccess.getStepDescriptionAccess().getSTEP_KEYWORDTerminalRuleCall_4()); 
            	        

            	    }
            	    break;

            	default :
            	    if ( cnt19 >= 1 ) break loop19;
                        EarlyExitException eee =
                            new EarlyExitException(19, input);
                        throw eee;
                }
                cnt19++;
            } while (true);


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStepDescription"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x00000000000143D0L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000014002L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x00000000000003D0L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020030L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000020020L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x00000000000203F0L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x00000000000203E0L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x00000000000003E0L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x00000000000003E2L});

}